String name = "Order";
int nameSeed=0;

int type = 0;
//0: grasshopper
//1: rhinoscript
//2: processing
color[] typeCols = {color(100,240,100),color(240,100,100),color(100,100,240)};

int s = 50;
int g = 3;

void setup(){
  size(300,300,P3D);
  smooth();
  
  ortho();
  lights();
  directionalLight(50,50,50,1,0,-1);
  translate(width/2, height/2);
  rotateX(radians(-45));
  rotateY(radians(45));
  
  String[] lines = loadStrings("names.txt");
  for(int m = 0; m<lines.length; m++){
    background(255);
    String[] infos = split(lines[m],',');
    type = int(float(infos[0]));
    name = infos[1];
    
    for(int i=0; i<name.length(); i++){
      char c = name.charAt(i);
      int ci = c;
      nameSeed = nameSeed + ci*i;
    }
    randomSeed(nameSeed);
    print(nameSeed+",");
    
    int bi = floor(random(g-1));
    int bn = floor(random(g-1));
    int bt = floor(random(g-1));
    println(bi+","+bn+","+bt);
    pushMatrix();
    translate(s*bi-(g-2)*s/2,s*bn-(g-2)*s/2,s*bt-(g-2)*s/2);
    fill(typeCols[type]);
    strokeWeight(3);
    stroke(255);
    box(s*2);
    popMatrix();
    
    for(int i=0; i<g; i++){
      for(int n=0; n<g; n++){
        for(int t=0; t<g; t++){
          if((bi>i || bi+1<i) || (bn>n || bn+1<n) || (bt>t || bt+1<t)){// && (bn>n || bn+1<n) && (bt>t || bt+1<t)){
            pushMatrix();
            translate(s*i-(g-1)*s/2,s*n-(g-1)*s/2,s*t-(g-1)*s/2);
            color col = typeCols[type];
            fill(red(col)+50+random(50),green(col)+50+random(50),blue(col)+50+random(50));
            
            stroke(255);
            if(random(1)<=0.5){
              box(s);
            }
            popMatrix();
          }
        }
      }  
    }
    
    save("save/"+name+".png");
    nameSeed = 0;
  }
  exit();
}
